#!/usr/bin/perl -w
#
# Virtual Vacation
# Version 0.1
#
# Christoph Handel, j.a.m. GmbH, June 2005
use DBI;

my $db_name = "db";
my $db_user = "xy";
my $db_pass = "secret";
my $sendmail = "/usr/sbin/sendmail";
my $returnpath = 'vacation@hostname.de';
my $logfile = "/var/spool/postvac/postvac.log";    # specify a file name here for example: vacation.log
my $debugfile = "/var/spool/postvac/debug.log";  # sepcify a file name here for example: vacation.debug

my $debug = 1;

$dbh = DBI->connect("DBI:mysql:$db_name", "$db_user", "$db_pass", { RaiseError => 1});

sub do_in_array {
    my ($val, @array) = @_;
    foreach (@array) {
	return 1 if $_ eq $val;
    }
    return 0;
}

sub do_query {    
   my ($query) = @_;
   if ($debugfile) { do_debug($query); }
   my $sth = $dbh->prepare($query) or die "Can't prepare $query: $dbh->errstr\n";
   $sth->execute or die "Can't execute the query: $sth->errstr";
   $sth;
}

sub do_debug {
   my ($msg) = @_;
   open (DEBUG, ">> $debugfile") or die ("Unable to open debug file");
   chop ($date = `date "+%Y/%m/%d %H:%M:%S"`);
   print DEBUG "$date: $msg\n";
   close (DEBUG);
}


sub do_cache {
   my ($from, $mailbox) = @_;    
   $query = qq{SELECT primkey FROM tbl_vacation_cache WHERE mailfrom='$from' AND mailbox='$mailbox' AND ((to_days(now()) - to_days(timestamp)) < 7)};
   $sth = do_query ($query);
   $rv = $sth->rows;
   if ($rv == 0) {
      $query = qq{INSERT INTO tbl_vacation_cache (mailfrom, mailbox) VALUES ('$from', '$mailbox')};
      $sth = do_query ($query);
   }
   return $rv;
}

sub do_log {
   my ($to, $from, $subject) = @_;
   open (LOG, ">> $logfile") or die ("Unable to open log file");
   chop ($date = `date "+%Y/%m/%d %H:%M:%S"`);
   print LOG "$date: $to - $from - $subject\n";
   close (LOG);
}
                              
sub do_mail {
   my ($to, $from, $subject, $body) = @_;
   open (MAIL, "| $sendmail " . "-r $returnpath -t ") or die ("Unable to open sendmail");
   print MAIL "From: $to\n";
   print MAIL "To: $from\n";
   print MAIL "Subject: $subject\n";
   print MAIL "X-Loop: jamcp virtual vacation\n\n";
   print MAIL "$body";
   close (MAIL);
   if ($debugfile) { do_debug("mail", $to, $from, $subject, $body); }
}




# get from and to
$from = $ARGV[0];
$user = $ARGV[1];

# don't answer postmaster
if ($from eq "" || $from =~ /^owner-|-(request|owner)\@|^(mailer-daemon|postmaster|vacation)\@/i) {
   exit (0);
}

# check if we have any entries for this mailbox
$query = qq{SELECT vac_subject, vac_message FROM tbl_vacation WHERE vac_user='$user'};
$sth = do_query ($query);
$rv = $sth->rows;
if ($rv == 0) {
    exit(0);
}
if (not @row = $sth->fetchrow_array) {
    exit (0);
}
$subject = $row[0];
$message = $row[1];

if (do_cache($from, $user) == 0) {
    do_mail($user, $from, $subject, $message);
}

exit(0);
